/**
 * DuMP3 version morpheus_0.2.9 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;
import java.util.Set;
import net.za.grasser.duplicate.compare.Comparer;
import net.za.grasser.duplicate.file.DirectoryInfo;
import net.za.grasser.duplicate.file.DirectoryReader;
import net.za.grasser.duplicate.file.ExtensionCount;
import net.za.grasser.duplicate.file.FingerprintFile;
import net.za.grasser.duplicate.file.WildcardFilter;
import net.za.grasser.duplicate.fingerprint.AbstractFingerprint;
import net.za.grasser.duplicate.fingerprint.FingerprintFactory;
import net.za.grasser.duplicate.gui.*;
import net.za.grasser.duplicate.gui.display.DoubleDisplay;
import net.za.grasser.duplicate.gui.display.DoubleDisplayFactory;
import net.za.grasser.duplicate.gui.info.DoubleInfo;
import net.za.grasser.duplicate.persist.DatabaseFactory;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.eclipse.jface.viewers.AbstractTreeViewer;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Sash;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.swt.widgets.TreeColumn;
import com.cloudgarden.resource.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose whatever) then you should purchase a license for each developer using Jigloo. Please
 * visit www.cloudgarden.com for details. Use of Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS
 * MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.54 $
 */
public class DuMP3 extends org.eclipse.swt.widgets.Composite implements Observer {
  static {
    Configure.load();
    PropertyConfigurator.configure("./log4j.properties");
    log = Logger.getLogger(DuMP3.class);
  }
  /**
   * <code>VERSION</code> DuMP3 -
   */
  private static final String VERSION = "morpheus_0.2.9";
  /**
   * <code>log</code> DuMP3 -
   */
  private static Logger log;
  /**
   * <code>display</code> DuMP3 -
   */
  private static Display display = null;
  /**
   * <code>tableViewer5</code> DuMP3 -
   */
  private TableViewer tableViewer5;
  /**
   * <code>composite5topImage</code> DuMP3 -
   */
  private Composite composite5topImage;
  /**
   * <code>composite5bottomImage</code> DuMP3 -
   */
  private Composite composite5bottomImage;
  /**
   * <code>composite5right</code> DuMP3 -
   */
  Composite composite5right;
  /**
   * <code>trashDir</code> DuMP3 - save current move directory
   */
  String trashDir = "";

  /**
   * This method should return an instance of this class which does NOT initialize it's GUI elements. This method is ONLY required by Jigloo if the superclass
   * of this class is abstract or non-public. It is not needed in any other situation.
   * 
   * @param parent
   * @param style
   * @return instance of this class which does NOT initialize it's GUI elements
   */
  public static Object getGUIBuilderInstance(final org.eclipse.swt.widgets.Composite parent, final int style) {
    return new DuMP3(parent, style, Boolean.FALSE);
  }

  /**
   * Auto-generated main method to display this org.eclipse.swt.widgets.Composite inside a new Shell.
   * 
   * @param args
   */
  public static void main(final String[] args) {
    log.debug("DuMP3 version " + VERSION + " started");
    final SplashScreen s = new SplashScreen(0);
    s.showSplash();
    display = Display.getDefault();
    log.debug("display created");
    final Shell shell = new Shell(display);
    log.debug("shell created");
    final DuMP3 inst = new DuMP3(shell, SWT.NULL);
    log.debug("dump3 instance created");
    final Point size = inst.getSize();
    shell.setLayout(new FillLayout());
    shell.setText("DuMP3 - the ultimate duplicate finder");
    shell.setImage(SWTResourceManager.getImage("icons/main.ico"));
    shell.layout();
    if (size.x == 0 && size.y == 0) {
      inst.pack();
      shell.pack();
    } else {
      final Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
      shell.setSize(shellBounds.width, shellBounds.height);
    }
    log.debug("shell configured");
    shell.open();
    log.debug("shell open");
    s.hideSplash();
    while (!shell.isDisposed()) {
      if (!display.readAndDispatch()) {
        display.sleep();
      }
    }
    log.debug("done");
    DatabaseFactory.getDatabase().close();
    log.debug("exit");
    // make sure all swing components are closed.
    System.exit(0);
  }

  {
    // Register as a resource user - SWTResourceManager will
    // handle the obtaining and disposing of resources
    SWTResourceManager.registerResourceUser(this);
  }
  /**
   * <code>treeViewer3</code> DuMP3 -
   */
  TreeViewer treeViewer3;
  /**
   * <code>composite5</code> DuMP3 -
   */
  Composite composite5;
  /**
   * <code>sash5</code> DuMP3 -
   */
  Sash sash5;
  /**
   * <code>sash5right</code> DuMP3 -
   */
  Sash sash5right;
  /**
   * <code>lblVersion</code> DuMP3 - version display bottom right
   */
  private Label lblVersion;
  /**
   * <code>toolItemLMove</code> DuMP3 -
   */
  ToolItem toolItemLMove;
  /**
   * <code>toolItemLDelete</code> DuMP3 -
   */
  ToolItem toolItemLDelete;
  /**
   * <code>toolItemLTrash</code> DuMP3 -
   */
  ToolItem toolItemLTrash;
  /**
   * <code>toolItemRTrash</code> DuMP3 -
   */
  ToolItem toolItemRTrash;
  /**
   * <code>toolItemRMove</code> DuMP3 -
   */
  ToolItem toolItemRMove;
  /**
   * <code>toolItemRDelete</code> DuMP3 -
   */
  ToolItem toolItemRDelete;
  /**
   * <code>toolBarLeft</code> DuMP3 -
   */
  private ToolBar toolBarLeft;
  /**
   * <code>toolBarRight</code> DuMP3 -
   */
  private ToolBar toolBarRight;
  /**
   * <code>fileList</code> DuMP3 - file list
   */
  private final List<File> fileList = Collections.synchronizedList(new ArrayList<File>());
  /**
   * <code>typeMap</code> DuMP3 - temporary file type list while collecting
   */
  private final Map<String, ExtensionCount> typeMap = Collections.synchronizedMap(new HashMap<String, ExtensionCount>());
  /**
   * <code>typeList</code> DuMP3 - displayed file type list
   */
  private final List<ExtensionCount> typeList = Collections.synchronizedList(new ArrayList<ExtensionCount>());
  /**
   * <code>duplicateList</code> DuMP3 - list of duplicates found
   */
  final List<FingerprintFile> duplicateList = Collections.synchronizedList(new ArrayList<FingerprintFile>());
  /**
   * <code>selectedTypeList</code> DuMP3 - selected file types
   */
  private final List<ExtensionCount> selectedTypeList = Collections.synchronizedList(new ArrayList<ExtensionCount>());
  /**
   * <code>prints</code> DuMP3 - fingerprint list
   */
  private final Set<Class< ? extends AbstractFingerprint>> prints = Collections.synchronizedSet(new HashSet<Class< ? extends AbstractFingerprint>>());
  /**
   * <code>tableViewer3</code> DuMP3 -
   */
  TableViewer tableViewer3;
  /**
   * <code>btnRem2</code> DuMP3 -
   */
  private Button btnRem2;
  /**
   * <code>btnAdd2</code> DuMP3 -
   */
  private Button btnAdd2;
  /**
   * <code>tableViewer2</code> DuMP3 -
   */
  private TableViewer tableViewer2;
  /**
   * <code>tableViewer4</code> DuMP3 -
   */
  private TableViewer tableViewer4;
  /**
   * <code>tableViewer1</code> DuMP3 -
   */
  TableViewer tableViewer1;
  /**
   * <code>composite2</code> DuMP3 -
   */
  private Composite composite2;
  /**
   * <code>composite3</code> DuMP3 -
   */
  private Composite composite3;
  /**
   * <code>buttonBar</code> DuMP3 -
   */
  private Composite buttonBar;
  /**
   * <code>btnRem1</code> DuMP3 -
   */
  private Button btnRem1;
  /**
   * <code>cTabItem3</code> DuMP3 -
   */
  CTabItem cTabItem3;
  /**
   * <code>lblStatus</code> DuMP3 -
   */
  Label lblStatus;
  /**
   * <code>cTabItem5</code> DuMP3 -
   */
  CTabItem cTabItem5;
  /**
   * <code>cTabItem6</code> DuMP3 -
   */
  private CTabItem cTabItem6;
  /**
   * <code>cTabItem4</code> DuMP3 -
   */
  private CTabItem cTabItem4;
  /**
   * <code>cTabItem2</code> DuMP3 -
   */
  CTabItem cTabItem2;
  /**
   * <code>btnAdd1</code> DuMP3 -
   */
  private Button btnAdd1;
  /**
   * <code>treeViewer1left</code> DuMP3 -
   */
  private TreeViewer treeViewer1left;
  /**
   * <code>treeViewer1right</code> DuMP3 -
   */
  private TreeViewer treeViewer1right;
  /**
   * <code>composite1</code> DuMP3 -
   */
  private Composite composite1;
  /**
   * <code>cTabItem1</code> DuMP3 -
   */
  private CTabItem cTabItem1;
  /**
   * <code>ctfMainTab</code> DuMP3 -
   */
  CTabFolder ctfMainTab;
  /**
   * <code>btnNext</code> DuMP3 -
   */
  Button btnNext;
  /**
   * <code>btnBack</code> DuMP3 -
   */
  Button btnBack;
  /**
   * <code>progressBar</code> DuMP3 -
   */
  ProgressBar progressBar;
  /**
   * <code>typeThreadsStarted</code> DuMP3 -
   */
  private int typeThreadsStarted = 0;
  /**
   * <code>progress</code> DuMP3 - finer control over the progress bar
   */
  double progress = 0.0;
  /**
   * <code>readers</code> DuMP3 -
   */
  private final List<DirectoryReader> readers = new ArrayList<DirectoryReader>();
  /**
   * <code>prevLeft</code> DuMP3 -
   */
  private FingerprintFile prevLeft = null;
  /**
   * <code>prevRight</code> DuMP3 -
   */
  private FingerprintFile prevRight = null;

  /**
   * @param parent
   * @param style
   */
  public DuMP3(final Composite parent, final int style) {
    super(parent, style);
    initGUI();
  }

  /**
   * This constructor is used by the getGUIBuilderInstance method to provide an instance of this class which has not had it's GUI elements initialized (ie,
   * initGUI is not called in this constructor).
   * 
   * @param parent
   * @param style
   * @param initGUI
   */
  public DuMP3(final org.eclipse.swt.widgets.Composite parent, final int style, final Boolean initGUI) {
    super(parent, style);
  }

  /**
   * @param evt
   */
  void btnAdd1WidgetSelected(final SelectionEvent evt) {
    if (!treeViewer1left.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)treeViewer1left.getSelection();
      final File f = (File)selection.getFirstElement();
      boolean found = false;
      for (final File lFile : fileList) {
        if (f.equals(lFile) || lFile.getPath().length() < f.getPath().length() && lFile.getPath().equals(f.getPath().substring(0, lFile.getPath().length()))) {
          found = true;
          break;
        }
      }
      if (!found) {
        fileList.add(f);
        treeViewer1right.refresh();
        lblStatus.setText((f.isDirectory() ? "Folder" : "File") + " added.");
        clearTab(2);
        clearTab(3);
        clearTab(4);
        clearTab(5);
        clearTab(6);
      } else {
        lblStatus.setText((f.isDirectory() ? "Folder" : "File") + " already selected!");
        lblStatus.setToolTipText("You can not add files or folders more than once.");
      }
    } else {
      lblStatus.setText("Nothing selected!");
      lblStatus.setToolTipText("Please select a file or folder in the left tree.");
    }
    btnNext.setEnabled(!fileList.isEmpty());
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnAdd2WidgetSelected(final SelectionEvent evt) {
    if (!tableViewer1.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)tableViewer1.getSelection();
      selectedTypeList.addAll(selection.toList());
      typeList.removeAll(selection.toList());
      tableViewer2.refresh();
      tableViewer1.refresh();
      lblStatus.setText("File type added.");
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
    } else {
      lblStatus.setText("Nothing selected!");
      lblStatus.setToolTipText("Please select a file type in the left list.");
    }
    btnNext.setEnabled(!selectedTypeList.isEmpty());
  }

  /**
   * @param evt
   */
  void btnBackWidgetSelected(final SelectionEvent evt) {
    if (ctfMainTab.getSelection() == cTabItem2) {
      ctfMainTab.setSelection(cTabItem1);
      btnNext.setEnabled(!fileList.isEmpty());
      btnBack.setEnabled(false);
    } else if (ctfMainTab.getSelection() == cTabItem3) {
      ctfMainTab.setSelection(cTabItem2);
      btnNext.setEnabled(!selectedTypeList.isEmpty());
      btnBack.setEnabled(true);
    }
  }

  /**
   * @param evt
   */
  void btnNextWidgetSelected(final SelectionEvent evt) {
    if (ctfMainTab.getSelection() == cTabItem1) {
      lblStatus.setText("Detecting file types...");
      final Iterator<File> it = fileList.iterator();
      clearTab(2);
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      while (it.hasNext()) {
        File f = it.next();
        String wc = "*";
        if (f.isFile()) {
          wc = f.getName();
          f = f.getParentFile();
        }
        final DirectoryInfo df = new DirectoryInfo(f.getPath());
        final DirectoryReader dr;
        try {
          dr = new DirectoryReader(wc, df);
          readers.add(dr);
          dr.addObserver(this);
          dr.start();
          typeThreadsStarted++;
        } catch (final FileNotFoundException fnf) {
          log.error("Oops", fnf);
        }
      }
    } else if (ctfMainTab.getSelection() == cTabItem2) {
      lblStatus.setText("Selecting fingerprint algorithms.");
      prints.clear();
      final Iterator<ExtensionCount> it = selectedTypeList.iterator();
      while (it.hasNext()) {
        prints.addAll(FingerprintFactory.getFingerprintTypes(it.next().toString()));
      }
      ctfMainTab.setSelection(cTabItem3);
      btnNext.setEnabled(true);
      btnBack.setEnabled(true);
      progressBar.setSelection(0);
      progress = 0.0;
      lblStatus.setText("Configure the fingerprint algorithms.");
      tableViewer3.refresh();
    } else if (ctfMainTab.getSelection() == cTabItem3) {
      ctfMainTab.setSelection(cTabItem5);
      btnNext.setEnabled(false);
      btnBack.setEnabled(true);
      String wc = "";
      progress = 0.0;
      int count = 0;
      for (final ExtensionCount lExt : selectedTypeList) {
        wc += "(" + WildcardFilter.createRegEx(lExt.toString()) + ")|";
        count += lExt.getCount();
      }
      progressBar.setMaximum(count);
      lblStatus.setText("Comparing " + count + " files...");
      if (wc.endsWith("|")) {
        wc = wc.substring(0, wc.length() - 1);
      }
      final Comparer compare = Comparer.getInstance();
      compare.addObserver(this);
      compare.start();
      for (final DirectoryReader lDr : readers) {
        try {
          lDr.setWildcard(wc, true);
          lDr.deleteObserver(this);
          compare.addReader(lDr);
          lDr.start();
        } catch (final FileNotFoundException fnf) {
          log.error("Oops", fnf);
        }
      }
    }
  }

  /**
   * @param evt
   */
  void btnRem1WidgetSelected(final SelectionEvent evt) {
    if (!treeViewer1right.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)treeViewer1right.getSelection();
      final File f = (File)selection.getFirstElement();
      final Iterator<File> it = fileList.iterator();
      boolean found = false;
      while (it.hasNext()) {
        if (f.equals(it.next())) {
          found = true;
          break;
        }
      }
      if (found) {
        fileList.remove(f);
        treeViewer1right.refresh();
        lblStatus.setText((f.isDirectory() ? "Folder" : "File") + " removed.");
        clearTab(2);
        clearTab(3);
        clearTab(4);
        clearTab(5);
        clearTab(6);
      } else {
        lblStatus.setText((f.isDirectory() ? "Folder" : "File") + " not removed.");
        lblStatus.setToolTipText("You can not remove subfolders or files. Choose something you have added.");
      }
    } else {
      lblStatus.setText("Nothing selected!");
      lblStatus.setToolTipText("Please select a file or folder in the right tree.");
    }
    btnNext.setEnabled(!fileList.isEmpty());
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnRem2WidgetSelected(final SelectionEvent evt) {
    if (!tableViewer2.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)tableViewer2.getSelection();
      selectedTypeList.removeAll(selection.toList());
      typeList.addAll(selection.toList());
      tableViewer1.refresh();
      tableViewer2.refresh();
      lblStatus.setText("File type removed.");
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
    } else {
      lblStatus.setText("Nothing selected!");
      lblStatus.setToolTipText("Please select a file type in the right list.");
    }
    btnNext.setEnabled(!selectedTypeList.isEmpty());
  }

  /**
   * This method clears the selected items on the specified tab panel.
   * 
   * @param pTab
   */
  private void clearTab(final int pTab) {
    switch (pTab) {
      default:
      case 1:
        fileList.clear();
        getTreeViewer1right().refresh();
        break;
      case 2:
        readers.clear();
        typeMap.clear();
        typeList.clear();
        selectedTypeList.clear();
        getTableViewer1().refresh();
        getTableViewer2().refresh();
        break;
      case 3:
        prints.clear();
        getTableViewer3().refresh();
        getTableViewer4().setInput(null);
        getTableViewer4().refresh();
        break;
      case 4:
        break;
      case 5:
        duplicateList.clear();
        getTreeViewer3().refresh();
        break;
      case 6:
        break;
    }
  }

  /**
   * @param evt
   */
  void ctfMainTabWidgetSelected(final SelectionEvent evt) {
    if (evt.getSource() instanceof CTabFolder) {
      final CTabFolder tf = (CTabFolder)evt.getSource();
      final CTabItem ti = tf.getSelection();
      if (ti == cTabItem1) {
        btnBack.setEnabled(false);
        btnNext.setEnabled(!fileList.isEmpty());
      } else if (ti == cTabItem2) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(!selectedTypeList.isEmpty());
      } else if (ti == cTabItem5) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(false);
      } else {
        btnBack.setEnabled(true);
        btnNext.setEnabled(true);
      }
    }
  }

  /**
   * @return Button
   */
  public Button getBtnAdd1() {
    if (btnAdd1 == null) {
      btnAdd1 = new Button(composite1, SWT.PUSH | SWT.CENTER);
      btnAdd1.setText(">");
      final FormData button2LData = new FormData();
      button2LData.width = 71;
      button2LData.height = 27;
      button2LData.left = new FormAttachment(451, 1000, 0);
      button2LData.right = new FormAttachment(540, 1000, 0);
      button2LData.top = new FormAttachment(39, 1000, 0);
      button2LData.bottom = new FormAttachment(92, 1000, 0);
      btnAdd1.setLayoutData(button2LData);
      btnAdd1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnAdd1WidgetSelected(evt);
        }
      });
    }
    return btnAdd1;
  }

  /**
   * @return Button
   */
  public Button getBtnAdd2() {
    if (btnAdd2 == null) {
      btnAdd2 = new Button(composite2, SWT.PUSH | SWT.CENTER);
      btnAdd2.setText(">");
      final FormData button1LData2 = new FormData();
      button1LData2.width = 71;
      button1LData2.height = 27;
      button1LData2.left = new FormAttachment(451, 1000, 0);
      button1LData2.right = new FormAttachment(540, 1000, 0);
      button1LData2.top = new FormAttachment(39, 1000, 0);
      button1LData2.bottom = new FormAttachment(92, 1000, 0);
      btnAdd2.setLayoutData(button1LData2);
      btnAdd2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnAdd2WidgetSelected(evt);
        }
      });
    }
    return btnAdd2;
  }

  /**
   * @return Button
   */
  public Button getBtnBack() {
    if (btnBack == null) {
      btnBack = new Button(buttonBar, SWT.PUSH | SWT.CENTER);
      final FormData btnNextLData = new FormData();
      btnNextLData.width = 70;
      btnNextLData.height = 28;
      btnNextLData.left = new FormAttachment(814, 1000, 0);
      btnNextLData.right = new FormAttachment(901, 1000, 0);
      btnNextLData.top = new FormAttachment(0, 1000, 1);
      btnNextLData.bottom = new FormAttachment(814, 1000, 0);
      btnBack.setLayoutData(btnNextLData);
      btnBack.setText("&Back");
      btnBack.setEnabled(false);
      btnBack.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnBackWidgetSelected(evt);
        }
      });
    }
    return btnBack;
  }

  /**
   * @return Button
   */
  public Button getBtnNext() {
    if (btnNext == null) {
      btnNext = new Button(buttonBar, SWT.PUSH | SWT.CENTER);
      btnNext.setText("&Next");
      final FormData button1LData = new FormData();
      button1LData.width = 63;
      button1LData.height = 28;
      button1LData.left = new FormAttachment(910, 1000, 0);
      button1LData.right = new FormAttachment(989, 1000, 0);
      button1LData.top = new FormAttachment(0, 1000, 1);
      button1LData.bottom = new FormAttachment(814, 1000, 0);
      btnNext.setLayoutData(button1LData);
      btnNext.setEnabled(false);
      btnNext.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnNextWidgetSelected(evt);
        }
      });
    }
    return btnNext;
  }

  /**
   * @return Button
   */
  public Button getBtnRem1() {
    if (btnRem1 == null) {
      btnRem1 = new Button(composite1, SWT.PUSH | SWT.CENTER);
      btnRem1.setText("<");
      final FormData button1LData1 = new FormData();
      button1LData1.width = 71;
      button1LData1.height = 25;
      button1LData1.left = new FormAttachment(451, 1000, 0);
      button1LData1.right = new FormAttachment(540, 1000, 0);
      button1LData1.top = new FormAttachment(108, 1000, 0);
      button1LData1.bottom = new FormAttachment(156, 1000, 0);
      btnRem1.setLayoutData(button1LData1);
      btnRem1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnRem1WidgetSelected(evt);
        }
      });
    }
    return btnRem1;
  }

  /**
   * @return Button
   */
  public Button getBtnRem2() {
    if (btnRem2 == null) {
      btnRem2 = new Button(composite2, SWT.PUSH | SWT.CENTER);
      btnRem2.setText("<");
      final FormData button2LData1 = new FormData();
      button2LData1.width = 71;
      button2LData1.height = 25;
      button2LData1.left = new FormAttachment(451, 1000, 0);
      button2LData1.right = new FormAttachment(540, 1000, 0);
      button2LData1.top = new FormAttachment(108, 1000, 0);
      button2LData1.bottom = new FormAttachment(156, 1000, 0);
      btnRem2.setLayoutData(button2LData1);
      btnRem2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnRem2WidgetSelected(evt);
        }
      });
    }
    return btnRem2;
  }

  /**
   * @return Composite
   */
  public Composite getButtonBar() {
    if (buttonBar == null) {
      buttonBar = new Composite(this, SWT.NONE);
      final FormLayout buttonBarLayout = new FormLayout();
      buttonBar.setLayout(buttonBarLayout);
      final FormData buttonBarLData = new FormData();
      buttonBarLData.width = 800;
      buttonBarLData.height = 35;
      buttonBarLData.left = new FormAttachment(0, 1000, 0);
      buttonBarLData.right = new FormAttachment(1000, 1000, 0);
      buttonBarLData.bottom = new FormAttachment(1000, 1000, -26);
      buttonBar.setLayoutData(buttonBarLData);
      buttonBar.setBackground(SWTResourceManager.getColor(212, 208, 200));
      getProgressBar();
      getBtnBack();
      getBtnNext();
    }
    return buttonBar;
  }

  /**
   * @return Composite
   */
  public Composite getComposite1() {
    if (composite1 == null) {
      composite1 = new Composite(ctfMainTab, SWT.NONE);
      cTabItem1.setControl(composite1);
      final FormLayout composite1Layout = new FormLayout();
      composite1.setLayout(composite1Layout);
      getTreeViewer1left();
      getTreeViewer1right();
      getBtnAdd1();
      getBtnRem1();
    }
    return composite1;
  }

  /**
   * @return Composite
   */
  public Composite getComposite2() {
    if (composite2 == null) {
      composite2 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite2Layout = new FormLayout();
      composite2.setLayout(composite2Layout);
      cTabItem2.setControl(composite2);
      getTableViewer1();
      getTableViewer2();
      getBtnAdd2();
      getBtnRem2();
    }
    return composite2;
  }

  /**
   * @return Composite
   */
  public Composite getComposite3() {
    if (composite3 == null) {
      composite3 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite3Layout = new FormLayout();
      composite3.setLayout(composite3Layout);
      cTabItem3.setControl(composite3);
      getTableViewer3();
      getTableViewer4();
      getTableViewer5();
    }
    return composite3;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewer5() {
    if (tableViewer5 == null) {
      tableViewer5 = new TableViewer(composite3, SWT.NONE);
      tableViewer5.getTable().setHeaderVisible(true);
      final FormData tableViewer5LData = new FormData();
      tableViewer5LData.width = 323;
      tableViewer5LData.height = 302;
      tableViewer5LData.left = new FormAttachment(563, 1000, 0);
      tableViewer5LData.right = new FormAttachment(1000, 1000, -5);
      tableViewer5LData.top = new FormAttachment(505, 1000, 0);
      tableViewer5LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewer5.getControl().setLayoutData(tableViewer5LData);
      final TableColumn tableColumn1;
      tableColumn1 = new TableColumn(tableViewer5.getTable(), SWT.LEFT);
      tableColumn1.setText("File Types scanned");
      tableColumn1.setWidth(320);
    }
    return tableViewer5;
  }

  /**
   * This method ...
   * 
   * @return Composite
   */
  private Composite getComposite5() {
    if (composite5 == null) {
      composite5 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite5Layout = new FormLayout();
      composite5.setLayout(composite5Layout);
      cTabItem5.setControl(composite5);
      sash5 = new Sash(composite5, SWT.VERTICAL);
      final int limit = 20, percent = 33;
      final FormData sashData = new FormData();
      sashData.left = new FormAttachment(percent, 0);
      sashData.top = new FormAttachment(0, 0);
      sashData.bottom = new FormAttachment(100, 0);
      sash5.setLayoutData(sashData);
      sash5.addListener(SWT.Selection, new Listener() {
        public void handleEvent(final Event e) {
          final Rectangle sashRect = sash5.getBounds();
          final Rectangle shellRect = composite5.getClientArea();
          final int right = shellRect.width - sashRect.width - limit;
          e.x = Math.max(Math.min(e.x, right), limit);
          if (e.x != sashRect.x) {
            sashData.left = new FormAttachment(0, e.x);
            composite5.layout();
          }
        }
      });
      getTreeViewer3();
      getComposite5right();
    }
    return composite5;
  }

  /**
   * @return Label
   */
  public Label getLblStatus() {
    if (lblStatus == null) {
      lblStatus = new Label(this, SWT.NONE);
      lblStatus.setText("Select files or folders.");
      final FormData lblStatusLData = new FormData();
      lblStatusLData.width = 553;
      lblStatusLData.height = 21;
      lblStatusLData.left = new FormAttachment(0, 1000, 5);
      lblStatusLData.bottom = new FormAttachment(1000, 1000, -2);
      lblStatusLData.top = new FormAttachment(1000, 1000, -23);
      lblStatusLData.right = new FormAttachment(700, 1000, 0);
      lblStatus.setLayoutData(lblStatusLData);
    }
    return lblStatus;
  }

  /**
   * @return Label
   */
  public Label getLblVersion() {
    if (lblVersion == null) {
      lblVersion = new Label(this, SWT.RIGHT);
      lblVersion.setText("Version: " + VERSION);
      final FormData labelVersionLData = new FormData();
      labelVersionLData.width = 231;
      labelVersionLData.height = 21;
      labelVersionLData.left = new FormAttachment(700, 1000, 0);
      labelVersionLData.right = new FormAttachment(1000, 1000, -2);
      labelVersionLData.top = new FormAttachment(1000, 1000, -23);
      labelVersionLData.bottom = new FormAttachment(1000, 1000, -2);
      lblVersion.setLayoutData(labelVersionLData);
    }
    return lblVersion;
  }

  /**
   * @return ProgressBar
   */
  private ProgressBar getProgressBar() {
    if (progressBar == null) {
      progressBar = new ProgressBar(buttonBar, SWT.SMOOTH);
      final FormData progressBarLData = new FormData();
      progressBarLData.width = 400;
      progressBarLData.height = 26;
      progressBarLData.left = new FormAttachment(0, 1000, 5);
      progressBarLData.top = new FormAttachment(0, 1000, 1);
      progressBarLData.right = new FormAttachment(500, 1000, 0);
      progressBarLData.bottom = new FormAttachment(814, 1000, 0);
      progressBar.setLayoutData(progressBarLData);
      progressBar.setSelection(0);
      progress = 0.0;
    }
    return progressBar;
  }

  /**
   * @return TableViewer
   */
  public TableViewer getTableViewer1() {
    if (tableViewer1 == null) {
      tableViewer1 = new TableViewer(composite2, SWT.BORDER | SWT.FULL_SELECTION | SWT.MULTI);
      final FormData listViewer1LData = new FormData();
      listViewer1LData.width = 67;
      listViewer1LData.height = 63;
      listViewer1LData.left = new FormAttachment(0, 1000, 3);
      listViewer1LData.top = new FormAttachment(0, 1000, 7);
      listViewer1LData.right = new FormAttachment(434, 1000, 0);
      listViewer1LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewer1.getControl().setLayoutData(listViewer1LData);
      tableViewer1.getTable().setHeaderVisible(true);
      final TableColumn column1 = new TableColumn(tableViewer1.getTable(), SWT.LEFT);
      column1.setText("Found File Types");
      column1.setWidth(160);
      final TableColumn column2 = new TableColumn(tableViewer1.getTable(), SWT.RIGHT);
      column2.setText("Number of files");
      column2.setWidth(160);
      tableViewer1.setContentProvider(new CollectionTableContentProvider());
      tableViewer1.setLabelProvider(new TypeTableLabelProvider());
      tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
      tableViewer1.setInput(typeList);
      column1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent e) {
          if (((ExtensionCountSorter)tableViewer1.getSorter()).getType() == ExtensionCountSorter.COUNT) {
            tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
          } else {
            if (((ExtensionCountSorter)tableViewer1.getSorter()).getDirection() == ExtensionCountSorter.ASC) {
              tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.DESC));
            } else {
              tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
            }
          }
        }
      });
      column2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent e) {
          if (((ExtensionCountSorter)tableViewer1.getSorter()).getType() == ExtensionCountSorter.EXT) {
            tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.DESC));
          } else {
            if (((ExtensionCountSorter)tableViewer1.getSorter()).getDirection() == ExtensionCountSorter.DESC) {
              tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.ASC));
            } else {
              tableViewer1.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.DESC));
            }
          }
        }
      });
    }
    return tableViewer1;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewer2() {
    if (tableViewer2 == null) {
      tableViewer2 = new TableViewer(composite2, SWT.BORDER | SWT.FULL_SELECTION | SWT.MULTI);
      final FormData tableViewer2LData = new FormData();
      tableViewer2LData.width = 12;
      tableViewer2LData.height = 61;
      tableViewer2LData.left = new FormAttachment(559, 1000, 0);
      tableViewer2LData.right = new FormAttachment(1000, 1000, -6);
      tableViewer2LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewer2LData.top = new FormAttachment(0, 1000, 6);
      tableViewer2.getControl().setLayoutData(tableViewer2LData);
      tableViewer2.getTable().setHeaderVisible(true);
      final TableColumn column1 = new TableColumn(tableViewer2.getTable(), SWT.LEFT);
      column1.setText("Selected File Types");
      column1.setWidth(320);
      tableViewer2.setContentProvider(new CollectionTableContentProvider());
      tableViewer2.setLabelProvider(new TypeTableLabelProvider());
      tableViewer2.setSorter(new StringSorter());
      tableViewer2.setInput(selectedTypeList);
    }
    return tableViewer2;
  }

  /**
   * @return TableViewer
   */
  public TableViewer getTableViewer3() {
    if (tableViewer3 == null) {
      tableViewer3 = new TableViewer(composite3, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
      final FormData tableViewer3LData = new FormData();
      tableViewer3LData.width = 67;
      tableViewer3LData.height = 63;
      tableViewer3LData.left = new FormAttachment(0, 1000, 3);
      tableViewer3LData.top = new FormAttachment(0, 1000, 7);
      tableViewer3LData.right = new FormAttachment(434, 1000, 0);
      tableViewer3LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewer3.getControl().setLayoutData(tableViewer3LData);
      tableViewer3.getTable().setHeaderVisible(true);
      final TableColumn column1 = new TableColumn(tableViewer3.getTable(), SWT.LEFT);
      column1.setText("Fingerprint Algorithms");
      column1.setWidth(200);
      final TableColumn column2 = new TableColumn(tableViewer3.getTable(), SWT.RIGHT);
      column2.setText("Percentage match");
      column2.setWidth(120);
      tableViewer3.setContentProvider(new CollectionTableContentProvider());
      tableViewer3.setLabelProvider(new FingerprintTableLabelProvider());
      tableViewer3.setSorter(new StringSorter());
      tableViewer3.setInput(prints);
      tableViewer3.addSelectionChangedListener(new ISelectionChangedListener() {
        public void selectionChanged(final SelectionChangedEvent pArg0) {
          tableViewer3WidgetSelected(pArg0);
        }
      });
    }
    return tableViewer3;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewer4() {
    if (tableViewer4 == null) {
      tableViewer4 = new TableViewer(composite3, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
      final FormData tableViewer4LData = new FormData();
      tableViewer4LData.width = 323;
      tableViewer4LData.height = 302;
      tableViewer4LData.left = new FormAttachment(563, 1000, 0);
      tableViewer4LData.right = new FormAttachment(1000, 1000, -5);
      tableViewer4LData.bottom = new FormAttachment(495, 1000, 0);
      tableViewer4LData.top = new FormAttachment(0, 1000, 7);
      tableViewer4.getControl().setLayoutData(tableViewer4LData);
      tableViewer4.getTable().setHeaderVisible(true);
      final TableColumn column1 = new TableColumn(tableViewer4.getTable(), SWT.LEFT);
      column1.setText("Property");
      column1.setWidth(160);
      final TableColumn column2 = new TableColumn(tableViewer4.getTable(), SWT.LEFT);
      column2.setText("Value");
      column2.setWidth(160);
      tableViewer4.setContentProvider(new FingerprintConfigContentProvider());
      tableViewer4.setLabelProvider(new FingerprintConfigLabelProvider());
      // tableViewer4.setInput(selectedTypeList);
    }
    return tableViewer4;
  }

  /**
   * @return TreeViewer
   */
  public TreeViewer getTreeViewer1left() {
    if (treeViewer1left == null) {
      treeViewer1left = new TreeViewer(composite1, SWT.BORDER | SWT.SINGLE);
      final FormData treeViewer1LData = new FormData();
      treeViewer1LData.width = 326;
      treeViewer1LData.height = 493;
      treeViewer1LData.left = new FormAttachment(0, 1000, 3);
      treeViewer1LData.top = new FormAttachment(0, 1000, 6);
      treeViewer1LData.bottom = new FormAttachment(994, 1000, 0);
      treeViewer1LData.right = new FormAttachment(434, 1000, 0);
      final TreeColumn column = new TreeColumn(treeViewer1left.getTree(), SWT.LEFT);
      column.setText("This Computer");
      column.setWidth(320);
      treeViewer1left.getControl().setLayoutData(treeViewer1LData);
      treeViewer1left.getTree().setBounds(0, 0, 346, 513);
      treeViewer1left.setContentProvider(new FileTreeContentProvider());
      treeViewer1left.setLabelProvider(new FileTreeLabelProvider());
      treeViewer1left.setInput(new File("*"));
      treeViewer1left.getTree().setHeaderVisible(true);
      // treeViewer1left.addFilter(new AllowOnlyFoldersFilter());
    }
    return treeViewer1left;
  }

  /**
   * @return TreeViewer
   */
  public TreeViewer getTreeViewer1right() {
    if (treeViewer1right == null) {
      treeViewer1right = new TreeViewer(composite1, SWT.BORDER);
      final FormData treeViewer2LData = new FormData();
      treeViewer2LData.width = 326;
      treeViewer2LData.height = 493;
      treeViewer2LData.left = new FormAttachment(559, 1000, 0);
      treeViewer2LData.right = new FormAttachment(1000, 1000, -6);
      treeViewer2LData.bottom = new FormAttachment(994, 1000, 0);
      treeViewer2LData.top = new FormAttachment(0, 1000, 6);
      final TreeColumn column = new TreeColumn(treeViewer1right.getTree(), SWT.LEFT);
      column.setText("Selected files and folders");
      column.setWidth(320);
      treeViewer1right.getControl().setLayoutData(treeViewer2LData);
      treeViewer1right.getTree().setBounds(450, 0, 346, 513);
      treeViewer1right.setContentProvider(new ListTreeContentProvider());
      treeViewer1right.setLabelProvider(new FileListLabelProvider());
      treeViewer1right.setInput(fileList);
      treeViewer1right.getTree().setHeaderVisible(true);
      // treeViewer1right.addFilter(new AllowOnlyFoldersFilter());
    }
    return treeViewer1right;
  }

  /**
   * This method ...
   * 
   * @return TreeViewer
   */
  private TreeViewer getTreeViewer3() {
    if (treeViewer3 == null) {
      treeViewer3 = new TreeViewer(composite5, SWT.BORDER | SWT.MULTI);
      final FormData treeViewer3LData = new FormData();
      treeViewer3LData.width = 232;
      treeViewer3LData.height = 484;
      treeViewer3LData.left = new FormAttachment(0, 1000, 3);
      treeViewer3LData.top = new FormAttachment(0, 1000, 6);
      treeViewer3LData.bottom = new FormAttachment(994, 1000, 0);
      // treeViewer3LData.right = new FormAttachment(333, 1000, 0);
      treeViewer3LData.right = new FormAttachment(sash5, 0);
      treeViewer3.getControl().setLayoutData(treeViewer3LData);
      final TreeColumn column = new TreeColumn(treeViewer3.getTree(), SWT.LEFT);
      column.setText("Duplicate Groups");
      column.setWidth(800);
      treeViewer3.setContentProvider(new FingerprintTreeContentProvider());
      treeViewer3.setLabelProvider(new FingerprintTreeLabelProvider());
      treeViewer3.setInput(duplicateList);
      treeViewer3.getTree().setHeaderVisible(true);
      treeViewer3.addPostSelectionChangedListener(new ISelectionChangedListener() {
        public void selectionChanged(final SelectionChangedEvent evt) {
          treeViewer3SelectionChanged(evt);
        }
      });
    }
    return treeViewer3;
  }

  /**
   * Initializes the GUI.
   */
  private void initGUI() {
    try {
      this.setSize(new org.eclipse.swt.graphics.Point(800, 600));
      this.setBackground(SWTResourceManager.getColor(212, 208, 200));
      final FormLayout thisLayout = new FormLayout();
      setLayout(thisLayout);
      getButtonBar();
      {
        ctfMainTab = new CTabFolder(this, SWT.NONE);
        final FormData ctfMainTabLData = new FormData();
        ctfMainTabLData.width = 396;
        ctfMainTabLData.height = 778;
        ctfMainTabLData.top = new FormAttachment(0, 1000, 0);
        ctfMainTabLData.left = new FormAttachment(0, 1000, 0);
        ctfMainTabLData.right = new FormAttachment(1000, 1000, 0);
        ctfMainTabLData.bottom = new FormAttachment(1000, 1000, -65);
        ctfMainTab.setLayoutData(ctfMainTabLData);
        getTabItem1();
        getTabItem2();
        getTabItem3();
        getTabItem4();
        getTabItem5();
        getTabItem6();
        ctfMainTab.setSelection(0);
        ctfMainTab.addSelectionListener(new SelectionAdapter() {
          @Override
          public void widgetSelected(final SelectionEvent evt) {
            ctfMainTabWidgetSelected(evt);
          }
        });
      }
      getLblStatus();
      getLblVersion();
      this.layout();
    } catch (final Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * This method will change the input in the config edit table.
   * 
   * @param evt
   */
  void tableViewer3WidgetSelected(final SelectionChangedEvent evt) {
    final IStructuredSelection selection = (IStructuredSelection)evt.getSelection();
    final Object first = selection.getFirstElement();
    tableViewer4.setInput(first);
  }

  /**
   * This method refreshes the results tree<br>
   * BUG 1548859 - Lost context
   */
  void refreshResults() {
    display.asyncExec(new Runnable() {
      @SuppressWarnings("unchecked")
      public void run() {
        synchronized (treeViewer3) {
          List<FingerprintFile> ffl = null;
          final StructuredSelection ss = (StructuredSelection)treeViewer3.getSelection();
          if (ss != null && !ss.isEmpty()) {
            ffl = ss.toList();
          }
          duplicateList.clear();
          duplicateList.addAll(Comparer.getInstance().getDuplicates());
          treeViewer3.refresh();
          if (treeViewer3.getTree().getItemCount() > 0) {
            if (ffl == null) {
              ffl = new ArrayList<FingerprintFile>();
              ffl.add((FingerprintFile)treeViewer3.getTree().getItem(0).getData());
            }
            treeViewer3.setSelection(new StructuredSelection(ffl), true);
            final StructuredSelection ss1 = (StructuredSelection)treeViewer3.getSelection();
            if (ss1 == null || ss1.isEmpty()) {
              ffl = new ArrayList<FingerprintFile>();
              ffl.add((FingerprintFile)treeViewer3.getTree().getItem(0).getData());
              treeViewer3.setSelection(new StructuredSelection(ffl), true);
            }
          }
        }
      }
    });
  }

  /**
   * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
   */
  public void update(final Observable pO, final Object pArg) {
    if (pArg instanceof FingerprintFile) {
      final FingerprintFile ff = (FingerprintFile)pArg;
      if (ff.getDuplicates() != null && !ff.getDuplicates().isEmpty()) {
        refreshResults();
        return;
      }
      final String s = ff.getExtension();
      final boolean added;
      if (typeMap.containsKey(s)) {
        final ExtensionCount wild = typeMap.get(s);
        wild.incCount();
        added = false;
      } else {
        final ExtensionCount wild = new ExtensionCount(ff.getExtension());
        typeMap.put(s, wild);
        added = true;
      }
      display.asyncExec(new Runnable() {
        public void run() {
          if (!progressBar.isDisposed()) {
            if (added) {
              progress += 1.0;
            } else {
              progress += 0.1;
            }
            progressBar.setSelection((int)progress % 101);
          }
        }
      });
    } else if (pArg instanceof String) {
      if (pO instanceof Comparer) {
        display.asyncExec(new Runnable() {
          public void run() {
            if (!lblStatus.isDisposed()) {
              lblStatus.setText("Finished comparing " + progressBar.getMaximum() + " files.");
            }
            refreshResults();
            if (!ctfMainTab.isDisposed()) {
              ctfMainTab.setSelection(cTabItem5);
              btnNext.setEnabled(true);
              btnBack.setEnabled(true);
            }
            if (!progressBar.isDisposed()) {
              progressBar.setSelection(0);
              progress = 0.0;
            }
          }
        });
        return;
      }
      typeThreadsStarted--;
      if (typeThreadsStarted <= 0) {
        typeList.clear();
        typeList.addAll(typeMap.values());
        try {
          Collections.sort(typeList);
        } catch (final Exception e) {
          e.printStackTrace();
        }
        display.asyncExec(new Runnable() {
          public void run() {
            if (!lblStatus.isDisposed()) {
              lblStatus.setText("Sorting file types. Please wait...");
            }
            tableViewer1.refresh();
            if (!ctfMainTab.isDisposed()) {
              ctfMainTab.setSelection(cTabItem2);
              btnNext.setEnabled(false);
              btnBack.setEnabled(true);
            }
            if (!progressBar.isDisposed()) {
              progressBar.setSelection(0);
              progress = 0.0;
            }
            if (!lblStatus.isDisposed()) {
              lblStatus.setText("Select file types you want to search.");
            }
          }
        });
      }
    } else if (pArg instanceof Integer) {
      display.asyncExec(new Runnable() {
        public void run() {
          if (!progressBar.isDisposed() && !lblStatus.isDisposed()) {
            synchronized (progressBar) {
              progress += ((Integer)pArg).doubleValue();
              progressBar.setSelection((int)progress);
              synchronized (lblStatus) {
                lblStatus.setText("Compared " + progressBar.getSelection() + "/" + progressBar.getMaximum() + " files...");
              }
            }
          }
        }
      });
    }
  }

  /**
   * @return cTabItem1
   */
  private CTabItem getTabItem1() {
    if (cTabItem1 == null) {
      cTabItem1 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem1.setText("Select Files");
      getComposite1();
    }
    return cTabItem1;
  }

  /**
   * @return cTabItem2
   */
  private CTabItem getTabItem2() {
    if (cTabItem2 == null) {
      cTabItem2 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem2.setText("Select Types");
      getComposite2();
    }
    return cTabItem2;
  }

  /**
   * @return cTabItem3
   */
  private CTabItem getTabItem3() {
    if (cTabItem3 == null) {
      cTabItem3 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem3.setText("Configure");
      getComposite3();
    }
    return cTabItem3;
  }

  /**
   * @return cTabItem4
   */
  private CTabItem getTabItem4() {
    if (cTabItem4 == null) {
      cTabItem4 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem4.setText("Automatic Rules");
    }
    return cTabItem4;
  }

  /**
   * @return cTabItem5
   */
  private CTabItem getTabItem5() {
    if (cTabItem5 == null) {
      cTabItem5 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem5.setText("Results");
      getComposite5();
    }
    return cTabItem5;
  }

  /**
   * @return cTabItem6
   */
  private CTabItem getTabItem6() {
    if (cTabItem6 == null) {
      cTabItem6 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem6.setText("Clean up");
    }
    return cTabItem6;
  }

  /**
   * @return composite5right
   */
  public Composite getComposite5right() {
    if (composite5right == null) {
      composite5right = new Composite(composite5, SWT.NONE);
      final FormLayout composite5rightLayout = new FormLayout();
      composite5right.setLayout(composite5rightLayout);
      final FormData composite5rightLData = new FormData();
      composite5rightLData.width = 63;
      composite5rightLData.height = 63;
      composite5rightLData.left = new FormAttachment(sash5, 0);
      composite5rightLData.top = new FormAttachment(0, 1000, 6);
      composite5rightLData.right = new FormAttachment(1000, 1000, -6);
      composite5rightLData.bottom = new FormAttachment(994, 1000, 0);
      composite5right.setLayoutData(composite5rightLData);
      sash5right = new Sash(composite5right, SWT.HORIZONTAL);
      final int limit = 26, percent = 70;
      final FormData sashData = new FormData();
      sashData.left = new FormAttachment(0, 0);
      sashData.top = new FormAttachment(percent, 0);
      sashData.right = new FormAttachment(100, 0);
      sash5right.setLayoutData(sashData);
      sash5right.addListener(SWT.Selection, new Listener() {
        public void handleEvent(final Event e) {
          final Rectangle sashRect = sash5right.getBounds();
          final Rectangle shellRect = composite5right.getClientArea();
          final int top = shellRect.height - sashRect.height - limit;
          e.y = Math.max(Math.min(e.y, top), limit);
          if (e.y != sashRect.y) {
            sashData.top = new FormAttachment(0, e.y);
            composite5right.layout();
          }
        }
      });
      getComposite5topImage();
      getToolBarLeft();
      getToolBarRight();
      getComposite5bottomImage();
    }
    return composite5right;
  }

  /**
   * @return composite5topImage
   */
  public Composite getComposite5topImage() {
    if (composite5topImage == null) {
      composite5topImage = DoubleDisplayFactory.getInstance().makeDoubleDisplay("image", composite5right, SWT.NONE);
      final FormLayout composite5topImageLayout = new FormLayout();
      composite5topImage.setLayout(composite5topImageLayout);
      final FormData composite5topImageLData = new FormData();
      composite5topImageLData.width = 63;
      composite5topImageLData.height = 63;
      composite5topImageLData.left = new FormAttachment(0, 1000, 0);
      composite5topImageLData.top = new FormAttachment(0, 1000, 0);
      composite5topImageLData.right = new FormAttachment(1000, 1000, 0);
      composite5topImageLData.bottom = new FormAttachment(sash5right, 0);
      composite5topImage.setLayoutData(composite5topImageLData);
    }
    return composite5topImage;
  }

  /**
   * @return composite5bottomImage
   */
  public Composite getComposite5bottomImage() {
    if (composite5bottomImage == null) {
      composite5bottomImage = new DoubleInfo(composite5right, SWT.NONE);
      final FormLayout composite5bottomImageLayout = new FormLayout();
      composite5bottomImage.setLayout(composite5bottomImageLayout);
      final FormData composite5bottomImageLData = new FormData();
      composite5bottomImageLData.width = 63;
      composite5bottomImageLData.height = 63;
      composite5bottomImageLData.left = new FormAttachment(0, 1000, 0);
      composite5bottomImageLData.top = new FormAttachment(sash5right, 31);
      composite5bottomImageLData.right = new FormAttachment(1000, 1000, 0);
      composite5bottomImageLData.bottom = new FormAttachment(1000, 1000, 0);
      composite5bottomImage.setLayoutData(composite5bottomImageLData);
    }
    return composite5bottomImage;
  }

  /**
   * @return ToolBar
   */
  public ToolBar getToolBarLeft() {
    if (toolBarLeft == null) {
      toolBarLeft = new ToolBar(composite5right, SWT.BORDER);
      final FormData toolBar1LData = new FormData();
      toolBar1LData.width = 248;
      toolBar1LData.height = 31;
      toolBar1LData.left = new FormAttachment(0, 1000, 0);
      toolBar1LData.top = new FormAttachment(sash5right, 0);
      toolBar1LData.bottom = new FormAttachment(sash5right, 31);
      toolBar1LData.right = new FormAttachment(500, 1000, -14);
      toolBarLeft.setLayoutData(toolBar1LData);
      getToolItemLDelete();
      getToolItemLTrash();
      getToolItemLMove();
    }
    return toolBarLeft;
  }

  /**
   * @return ToolBar
   */
  public ToolBar getToolBarRight() {
    if (toolBarRight == null) {
      toolBarRight = new ToolBar(composite5right, SWT.BORDER);
      final FormData toolBar1RData = new FormData();
      toolBar1RData.width = 255;
      toolBar1RData.height = 31;
      toolBar1RData.left = new FormAttachment(500, 1000, 14);
      toolBar1RData.top = new FormAttachment(sash5right, 0);
      toolBar1RData.bottom = new FormAttachment(sash5right, 31);
      toolBar1RData.right = new FormAttachment(1000, 1000, 0);
      toolBarRight.setLayoutData(toolBar1RData);
      getToolItemRDelete();
      getToolItemRTrash();
      getToolItemRMove();
    }
    return toolBarRight;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLDelete() {
    if (toolItemLDelete == null) {
      toolItemLDelete = new ToolItem(toolBarLeft, SWT.PUSH);
      toolItemLDelete.setImage(SWTResourceManager.getImage("icons/remove.gif"));
      toolItemLDelete.setToolTipText("permanent delete");
      toolItemLDelete.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLDeleteWidgetSelected(evt);
        }
      });
    }
    return toolItemLDelete;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLTrash() {
    if (toolItemLTrash == null) {
      toolItemLTrash = new ToolItem(toolBarLeft, SWT.PUSH);
      toolItemLTrash.setImage(SWTResourceManager.getImage("icons/trash_can.gif"));
      toolItemLTrash.setToolTipText("move to trash");
      toolItemLTrash.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLTrashWidgetSelected(evt);
        }
      });
    }
    return toolItemLTrash;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLMove() {
    if (toolItemLMove == null) {
      toolItemLMove = new ToolItem(toolBarLeft, SWT.PUSH);
      toolItemLMove.setImage(SWTResourceManager.getImage("icons/move.gif"));
      toolItemLMove.setToolTipText("move");
      toolItemLMove.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLMoveWidgetSelected(evt);
        }
      });
    }
    return toolItemLMove;
  }

  /**
   * @return ToolItem - Returns the toolItemRDelete.
   */
  public ToolItem getToolItemRDelete() {
    if (toolItemRDelete == null) {
      toolItemRDelete = new ToolItem(toolBarRight, SWT.PUSH);
      toolItemRDelete.setImage(SWTResourceManager.getImage("icons/remove.gif"));
      toolItemRDelete.setToolTipText("permanent delete");
      toolItemRDelete.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRDeleteWidgetSelected(evt);
        }
      });
    }
    return toolItemRDelete;
  }

  /**
   * @return ToolItem - Returns the toolItemRTrash.
   */
  public ToolItem getToolItemRTrash() {
    if (toolItemRTrash == null) {
      toolItemRTrash = new ToolItem(toolBarRight, SWT.PUSH);
      toolItemRTrash.setImage(SWTResourceManager.getImage("icons/trash_can.gif"));
      toolItemRTrash.setToolTipText("move to trash");
      toolItemRTrash.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRTrashWidgetSelected(evt);
        }
      });
    }
    return toolItemRTrash;
  }

  /**
   * @return ToolItem - Returns the toolItemRMove.
   */
  public ToolItem getToolItemRMove() {
    if (toolItemRMove == null) {
      toolItemRMove = new ToolItem(toolBarRight, SWT.PUSH);
      toolItemRMove.setImage(SWTResourceManager.getImage("icons/move.gif"));
      toolItemRMove.setToolTipText("move");
      toolItemRMove.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRMoveWidgetSelected(evt);
        }
      });
    }
    return toolItemRMove;
  }

  /**
   * This method hides all result displays
   */
  void hideDisplays() {
    getComposite5topImage().setVisible(false);
    ((DoubleDisplay)getComposite5topImage()).display(null, null);
    // getComposite5topText().setVisible(false);
    // getComposite5topAudio().setVisible(false);
    // getComposite5topBinary().setVisible(false);
    ((DoubleInfo)getComposite5bottomImage()).display(null, null);
  }

  /**
   * This method will change the selection of treeViewer3
   * 
   * @param pLeft
   * @param pRight
   */
  private void treeViewer3ChangeSelection(final FingerprintFile pLeft, final FingerprintFile pRight) {
    if (pLeft == null || pRight == null) {
      return;
    }
    display.asyncExec(new Runnable() {
      public void run() {
        final List<FingerprintFile> sel = new ArrayList<FingerprintFile>();
        sel.add(pLeft);
        sel.add(pRight);
        synchronized (treeViewer3) {
          treeViewer3.expandToLevel(pLeft, AbstractTreeViewer.ALL_LEVELS);
          treeViewer3.reveal(pRight);
          treeViewer3.setSelection(new StructuredSelection(sel), true);
        }
      }
    });
  }

  /**
   * This method shows the files in the right pane.<BR>
   * BUG 1548859 - Lost context
   * 
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void treeViewer3SelectionChanged(final SelectionChangedEvent evt) {
    final IStructuredSelection selection = (IStructuredSelection)evt.getSelection();
    if (selection == null || selection.isEmpty()) {
      hideDisplays();
      return;
    }
    FingerprintFile left = null;
    FingerprintFile right = null;
    final List<FingerprintFile> sel = selection.toList();
    if (sel.size() > 1) {
      left = sel.get(0);
      right = sel.get(1);
      if (sel.size() > 2) {
        // only two files selected at once
        treeViewer3ChangeSelection(left, right);
        return;
      }
    } else {
      final FingerprintFile first = (FingerprintFile)selection.getFirstElement();
      // work out left and right file
      if (first.getCompared() == null) {
        // top element - first sub is right
        left = first;
        right = first.getDuplicates().get(0);
      } else {
        // a compared element - parent is left
        left = first.getCompared();
        right = first;
      }
      treeViewer3ChangeSelection(left, right);
      return;
    }
    if (left == prevLeft && right == prevRight) {
      // keep context
      return;
    }
    prevLeft = left;
    prevRight = right;
    displayCompare(left, right);
  }

  /**
   * This method displays the compare window
   * 
   * @param left
   * @param right
   */
  private void displayCompare(final FingerprintFile left, final FingerprintFile right) {
    log.debug("Left:" + left.toString());
    log.debug("Right:" + right.toString());
    display.asyncExec(new Runnable() {
      public void run() {
        synchronized (toolItemLDelete) {
          if (!toolItemLDelete.isDisposed()) {
            toolItemLDelete.setData(left);
          }
          if (!toolItemRDelete.isDisposed()) {
            toolItemRDelete.setData(right);
          }
          if (!toolItemLTrash.isDisposed()) {
            toolItemLTrash.setData(left);
          }
          if (!toolItemRTrash.isDisposed()) {
            toolItemRTrash.setData(left);
          }
          if (!toolItemLMove.isDisposed()) {
            toolItemLMove.setData(left);
          }
          if (!toolItemRMove.isDisposed()) {
            toolItemRMove.setData(right);
          }
        }
        // hide all composites
        hideDisplays();
        // info display
        ((DoubleInfo)getComposite5bottomImage()).display(left, right);
        // top display
        final List<Class< ? extends AbstractFingerprint>> s = FingerprintFactory.getFingerprintTypes(left.getExtension());
        final Iterator<Class< ? extends AbstractFingerprint>> it = s.iterator();
        int type = -1;
        while (it.hasNext()) {
          final Class< ? > cls = it.next();
          if (cls.getName().indexOf("ColorFingerprint") >= 0) {
            getComposite5topImage().setVisible(true);
            ((DoubleDisplay)getComposite5topImage()).display(left, right);
            type = 1;
          }
          if (cls.getName().indexOf("FdmfFingerprint") >= 0) {
            // getComposite5topAudio().setVisible(true);
            type = 2;
          }
          if (cls.getName().indexOf("SifFingerprint") >= 0 || cls.getName().indexOf("SubstringFingerprint") >= 0) {
            // getComposite5topText().setVisible(true);
            type = 3;
          }
        }
        if (type < 0) {
          // getComposite5topBinary().setVisible(true);
        }
      }
    });
  }

  /**
   * This method will pop up a File selector box and move the file.
   * 
   * @param pFile
   */
  private void moveFile(final FingerprintFile pFile) {
    final FileDialog fileMover = new FileDialog(getShell(), SWT.SAVE);
    fileMover.setText("Move duplicate file");
    fileMover.setFilterPath(new File(pFile.getPath()).getParentFile().getPath());
    fileMover.setFileName(new File(pFile.getPath()).getName());
    // TODO get extensions/types from FingerprintFactory
    fileMover.setFilterNames(new String[]{
      "All Files (*.*)"
    });
    fileMover.setFilterExtensions(new String[]{
      "*.*"
    });
    final String filename = fileMover.open();
    if (filename != null) {
      final File fTo = new File(filename);
      final File fFrom = new File(pFile.getPath());
      if (fFrom.renameTo(fTo)) {
        lblStatus.setText(fFrom.getName() + " moved to " + fTo.getPath());
        Comparer.getInstance().removeFile(pFile);
        refreshResults();
      } else {
        lblStatus.setText(fFrom.getName() + " not moved.");
      }
    }
  }

  /**
   * This method will ask for a trash directory and after that will move the files into that dir.
   * 
   * @param pFile
   */
  private void trashFile(final FingerprintFile pFile) {
    final FileDialog fileMover = new FileDialog(getShell(), SWT.SAVE);
    fileMover.setText("Select trash directory");
    if (trashDir == null || trashDir.equals("")) {
      trashDir = new File(pFile.getPath()).getParentFile().getPath();
      fileMover.setFilterPath(trashDir);
      fileMover.setFileName(new File(pFile.getPath()).getName());
      // TODO get extensions/types from FingerprintFactory
      fileMover.setFilterNames(new String[]{
        "All Files (*.*)"
      });
      fileMover.setFilterExtensions(new String[]{
        "*.*"
      });
      final String filename = fileMover.open();
      if (filename != null) {
        trashDir = fileMover.getFilterPath();
      } else {
        lblStatus.setText(pFile.getName() + " not moved.");
        return;
      }
    }
    final File fFrom = new File(pFile.getPath());
    String name = pFile.getName();
    String ext = "";
    if (name.indexOf('.') >= 0) {
      ext = name.substring(name.indexOf('.'));
      name = name.substring(0, name.indexOf('.'));
    }
    File fTo = new File(trashDir + File.separator + name + ext);
    int count = 1;
    while (fTo.exists()) {
      fTo = new File(trashDir + File.separator + name + "_" + (count++) + ext);
    }
    if (fFrom.renameTo(fTo)) {
      lblStatus.setText(fFrom.getName() + " moved to " + fTo.getPath());
      Comparer.getInstance().removeFile(pFile);
      refreshResults();
    } else {
      lblStatus.setText(pFile.getName() + " could not be not moved.");
    }
  }

  /**
   * This method deletes the file and refreshes the tree
   * 
   * @param pFile
   */
  private void deleteFile(final FingerprintFile pFile) {
    final File f = new File(pFile.getPath());
    if (f.delete()) {
      lblStatus.setText(f.getName() + " deleted.");
      Comparer.getInstance().removeFile(pFile);
      refreshResults();
    } else {
      lblStatus.setText(f.getName() + " not deleted.");
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemLDeleteWidgetSelected(final SelectionEvent evt) {
    deleteFile((FingerprintFile)evt.widget.getData());
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemLMoveWidgetSelected(final SelectionEvent evt) {
    moveFile((FingerprintFile)evt.widget.getData());
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemRDeleteWidgetSelected(final SelectionEvent evt) {
    deleteFile((FingerprintFile)evt.widget.getData());
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemRMoveWidgetSelected(final SelectionEvent evt) {
    moveFile((FingerprintFile)evt.widget.getData());
  }

  /**
   * This method ...
   * 
   * @param pEvt
   */
  void toolItemRTrashWidgetSelected(final SelectionEvent pEvt) {
    trashFile((FingerprintFile)pEvt.widget.getData());
  }

  /**
   * This method ...
   * 
   * @param pEvt
   */
  void toolItemLTrashWidgetSelected(final SelectionEvent pEvt) {
    trashFile((FingerprintFile)pEvt.widget.getData());
  }
}